#include <Servo.h>

Servo allServos[4];                // create servo objects to control a servo
String serialString;              // incoming serial string
String servoPositionSubstring;    // we use this to store the substrings we extract from the incoming serial string
int servoPositions[4];            // store positions of the servos in this array of integers

void setup() {
  for (int i = 0; i < 4; i++) {
    allServos[i].attach(5 + i);  // asign the servoes to a pin starting at 5
    allServos[i].write(0);       // set the servos to thier zero position
  }

  Serial.begin(57600);          // setup the serial oject with a baud rate
}

void loop() {
  /*
    there is nothing in the loop because we are using the serial event method
  */
}

/*
  SerialEvent occurs whenever a new data comes in the hardware serial RX. This
  routine is run between each time loop() runs, so using delay inside loop can
  delay response. Multiple bytes of data may be available.
*/


void serialEvent() {
  while (Serial.available()) {

    serialString = Serial.readString();

    // the serial messages are sent as a string with the format A001B001C001D001| we use substring with indexOf to separate the servo positions we want from the rest of the string and then convert them to integers

    servoPositionSubstring = serialString.substring(serialString.indexOf('A') + 1, serialString.indexOf('B') );
    servoPositions[0] = servoPositionSubstring.toInt();

    servoPositionSubstring = serialString.substring(serialString.indexOf('B') + 1, serialString.indexOf('C') );
    servoPositions[1] = servoPositionSubstring.toInt();

    servoPositionSubstring = serialString.substring(serialString.indexOf('C') + 1, serialString.indexOf('D') );
    servoPositions[2] = servoPositionSubstring.toInt();

    servoPositionSubstring = serialString.substring(serialString.indexOf('D') + 1, serialString.indexOf('|') );
    servoPositions[3] = servoPositionSubstring.toInt();
  }

  // once we have filled the array of positions with the values extracted from the serial message we can write them to the servos
  for (int i = 0; i < 4; i++) {
    allServos[i].write(servoPositions[i]);
  }

}
